#include <iostream>

template<typename T>
class B { 
public:
  T i;
  B() : i(42) { std::cout << "B()" << std::endl; }
  virtual ~B() { std::cout << "~B()" << std::endl; }
  void print() { std::cout << i << std::endl; }
};

template<typename T>
class D1 : public B<T> { 
public:
  D1() : B<T>() { std::cout << "D1()" << std::endl; }
  ~D1() { std::cout << "~D1()" << std::endl; }
};

template<typename T>
class D2 : public D1<T> { 
public:
  D2() : D1<T>() { std::cout << "D2()" << std::endl; }
  ~D2() { std::cout << "~D2()" << std::endl; }
};

int main() { D2<int> c; c.print(); }

