#include <iostream>

class B { 
public:
  int i;
  B() { std::cout << "B()" << std::endl; }
  ~B() { std::cout << "~B()" << std::endl; }
  void print() { std::cout << this << std::endl; }
};

class D1 : public B { 
public:
  D1() { std::cout << "D1()" << std::endl; }
  ~D1() { std::cout << "~D1()" << std::endl; }
};

class D2 : public B { 
public:
  D2() { std::cout << "D2()" << std::endl; }
  ~D2() { std::cout << "~D2()" << std::endl; }
};

class D : public D1, public D2 { 
public:
  D() { std::cout << "D()" << std::endl; }
  ~D() { std::cout << "~D()" << std::endl; }
};

int main() { 
  D c; 
  c.D1::print(); 
  c.D2::print(); 
}

